diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/ff-mac-sched-sap.h ns-3.39/src/lte/model/ff-mac-sched-sap.h
--- ns-3.38/src/lte/model/ff-mac-sched-sap.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/ff-mac-sched-sap.h	2023-07-05 14:23:48.009428000 -0700
@@ -65,8 +65,7 @@
         uint16_t m_rlcRetransmissionHolDelay;    ///< RLC retransmission HOL delay
         uint16_t m_rlcStatusPduSize;             ///< RLC status PDU size
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -75,11 +74,10 @@
      */
     struct SchedDlPagingBufferReqParameters
     {
-        uint16_t m_rnti;                                              ///< RNTI
-        std::vector<struct PagingInfoListElement_s> m_pagingInfoList; ///< paging info list
+        uint16_t m_rnti;                                       ///< RNTI
+        std::vector<PagingInfoListElement_s> m_pagingInfoList; ///< paging info list
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -88,11 +86,10 @@
      */
     struct SchedDlMacBufferReqParameters
     {
-        uint16_t m_rnti;            ///< RNTI
-        enum CeBitmap_e m_ceBitmap; ///< CE bitmap
+        uint16_t m_rnti;       ///< RNTI
+        CeBitmap_e m_ceBitmap; ///< CE bitmap
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -101,11 +98,10 @@
      */
     struct SchedDlTriggerReqParameters
     {
-        uint16_t m_sfnSf;                                     ///< sfn SF
-        std::vector<struct DlInfoListElement_s> m_dlInfoList; ///< DL info list
+        uint16_t m_sfnSf;                              ///< sfn SF
+        std::vector<DlInfoListElement_s> m_dlInfoList; ///< DL info list
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -114,11 +110,10 @@
      */
     struct SchedDlRachInfoReqParameters
     {
-        uint16_t m_sfnSf;                                 ///< sfn SF
-        std::vector<struct RachListElement_s> m_rachList; ///< RACH list
+        uint16_t m_sfnSf;                          ///< sfn SF
+        std::vector<RachListElement_s> m_rachList; ///< RACH list
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -127,11 +122,10 @@
      */
     struct SchedDlCqiInfoReqParameters
     {
-        uint16_t m_sfnSf;                               ///< sfn SF
-        std::vector<struct CqiListElement_s> m_cqiList; ///< CQI list
+        uint16_t m_sfnSf;                        ///< sfn SF
+        std::vector<CqiListElement_s> m_cqiList; ///< CQI list
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -140,11 +134,10 @@
      */
     struct SchedUlTriggerReqParameters
     {
-        uint16_t m_sfnSf;                                     ///< sfn SF
-        std::vector<struct UlInfoListElement_s> m_ulInfoList; ///< UL info list
+        uint16_t m_sfnSf;                              ///< sfn SF
+        std::vector<UlInfoListElement_s> m_ulInfoList; ///< UL info list
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -157,8 +150,7 @@
         uint16_t m_rip;   ///< RIP
         uint16_t m_tnp;   ///< TNP
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -167,11 +159,10 @@
      */
     struct SchedUlSrInfoReqParameters
     {
-        uint16_t m_sfnSf;                             ///< sfn SF
-        std::vector<struct SrListElement_s> m_srList; ///< SR list
+        uint16_t m_sfnSf;                      ///< sfn SF
+        std::vector<SrListElement_s> m_srList; ///< SR list
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -180,11 +171,10 @@
      */
     struct SchedUlMacCtrlInfoReqParameters
     {
-        uint16_t m_sfnSf;                                   ///< sfn SF
-        std::vector<struct MacCeListElement_s> m_macCeList; ///< MAC CE list
+        uint16_t m_sfnSf;                            ///< sfn SF
+        std::vector<MacCeListElement_s> m_macCeList; ///< MAC CE list
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -193,11 +183,10 @@
      */
     struct SchedUlCqiInfoReqParameters
     {
-        uint16_t m_sfnSf;       ///< sfn SF
-        struct UlCqi_s m_ulCqi; ///< UL CQI
+        uint16_t m_sfnSf; ///< sfn SF
+        UlCqi_s m_ulCqi;  ///< UL CQI
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     //
@@ -210,49 +199,49 @@
      *
      * \param params SchedDlRlcBufferReqParameters
      */
-    virtual void SchedDlRlcBufferReq(const struct SchedDlRlcBufferReqParameters& params) = 0;
+    virtual void SchedDlRlcBufferReq(const SchedDlRlcBufferReqParameters& params) = 0;
 
     /**
      * \brief SCHED_DL_PAGING_BUFFER_REQ
      *
      * \param params SchedDlPagingBufferReqParameters
      */
-    virtual void SchedDlPagingBufferReq(const struct SchedDlPagingBufferReqParameters& params) = 0;
+    virtual void SchedDlPagingBufferReq(const SchedDlPagingBufferReqParameters& params) = 0;
 
     /**
      * \brief SCHED_DL_MAC_BUFFER_REQ
      *
      * \param params SchedDlMacBufferReqParameters
      */
-    virtual void SchedDlMacBufferReq(const struct SchedDlMacBufferReqParameters& params) = 0;
+    virtual void SchedDlMacBufferReq(const SchedDlMacBufferReqParameters& params) = 0;
 
     /**
      * \brief SCHED_DL_TRIGGER_REQ
      *
      * \param params SchedDlTriggerReqParameters
      */
-    virtual void SchedDlTriggerReq(const struct SchedDlTriggerReqParameters& params) = 0;
+    virtual void SchedDlTriggerReq(const SchedDlTriggerReqParameters& params) = 0;
 
     /**
      * \brief SCHED_DL_RACH_INFO_REQ
      *
      * \param params SchedDlRachInfoReqParameters
      */
-    virtual void SchedDlRachInfoReq(const struct SchedDlRachInfoReqParameters& params) = 0;
+    virtual void SchedDlRachInfoReq(const SchedDlRachInfoReqParameters& params) = 0;
 
     /**
      * \brief SCHED_DL_CQI_INFO_REQ
      *
      * \param params SchedDlCqiInfoReqParameters
      */
-    virtual void SchedDlCqiInfoReq(const struct SchedDlCqiInfoReqParameters& params) = 0;
+    virtual void SchedDlCqiInfoReq(const SchedDlCqiInfoReqParameters& params) = 0;
 
     /**
      * \brief SCHED_UL_TRIGGER_REQ
      *
      * \param params SchedUlTriggerReqParameters
      */
-    virtual void SchedUlTriggerReq(const struct SchedUlTriggerReqParameters& params) = 0;
+    virtual void SchedUlTriggerReq(const SchedUlTriggerReqParameters& params) = 0;
 
     /**
      * \brief SCHED_UL_NOISE_INTERFERENCE_REQ
@@ -260,28 +249,28 @@
      * \param params SchedUlNoiseInterferenceReqParameters
      */
     virtual void SchedUlNoiseInterferenceReq(
-        const struct SchedUlNoiseInterferenceReqParameters& params) = 0;
+        const SchedUlNoiseInterferenceReqParameters& params) = 0;
 
     /**
      * \brief SCHED_UL_SR_INFO_REQ
      *
      * \param params SchedUlSrInfoReqParameters
      */
-    virtual void SchedUlSrInfoReq(const struct SchedUlSrInfoReqParameters& params) = 0;
+    virtual void SchedUlSrInfoReq(const SchedUlSrInfoReqParameters& params) = 0;
 
     /**
      * \brief SCHED_UL_MAC_CTRL_INFO_REQ
      *
      * \param params SchedUlMacCtrlInfoReqParameters
      */
-    virtual void SchedUlMacCtrlInfoReq(const struct SchedUlMacCtrlInfoReqParameters& params) = 0;
+    virtual void SchedUlMacCtrlInfoReq(const SchedUlMacCtrlInfoReqParameters& params) = 0;
 
     /**
      * \brief SCHED_UL_CQI_INFO_REQ
      *
      * \param params SchedUlCqiInfoReqParameters
      */
-    virtual void SchedUlCqiInfoReq(const struct SchedUlCqiInfoReqParameters& params) = 0;
+    virtual void SchedUlCqiInfoReq(const SchedUlCqiInfoReqParameters& params) = 0;
 
   private:
 };
@@ -302,15 +291,13 @@
      */
     struct SchedDlConfigIndParameters
     {
-        std::vector<struct BuildDataListElement_s> m_buildDataList; ///< build data list
-        std::vector<struct BuildRarListElement_s> m_buildRarList;   ///< build rar list
-        std::vector<struct BuildBroadcastListElement_s>
-            m_buildBroadcastList; ///< build broadcast list
+        std::vector<BuildDataListElement_s> m_buildDataList;           ///< build data list
+        std::vector<BuildRarListElement_s> m_buildRarList;             ///< build rar list
+        std::vector<BuildBroadcastListElement_s> m_buildBroadcastList; ///< build broadcast list
 
         uint8_t m_nrOfPdcchOfdmSymbols; ///< number of PDCCH OFDM symbols
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     /**
@@ -319,11 +306,10 @@
      */
     struct SchedUlConfigIndParameters
     {
-        std::vector<struct UlDciListElement_s> m_dciList;   ///< DCI list
-        std::vector<struct PhichListElement_s> m_phichList; ///< PHICH list
+        std::vector<UlDciListElement_s> m_dciList;   ///< DCI list
+        std::vector<PhichListElement_s> m_phichList; ///< PHICH list
 
-        std::vector<struct VendorSpecificListElement_s>
-            m_vendorSpecificList; ///< vendor specific list
+        std::vector<VendorSpecificListElement_s> m_vendorSpecificList; ///< vendor specific list
     };
 
     //
@@ -336,14 +322,14 @@
      *
      * \param params SchedDlConfigIndParameters
      */
-    virtual void SchedDlConfigInd(const struct SchedDlConfigIndParameters& params) = 0;
+    virtual void SchedDlConfigInd(const SchedDlConfigIndParameters& params) = 0;
 
     /**
      * \brief SCHED_UL_CONFIG_IND
      *
      * \param params SchedUlConfigIndParameters
      */
-    virtual void SchedUlConfigInd(const struct SchedUlConfigIndParameters& params) = 0;
+    virtual void SchedUlConfigInd(const SchedUlConfigIndParameters& params) = 0;
 
   private:
 };
@@ -364,18 +350,17 @@
     MemberSchedSapProvider() = delete;
 
     // inherited from FfMacSchedSapProvider
-    void SchedDlRlcBufferReq(const struct SchedDlRlcBufferReqParameters& params) override;
-    void SchedDlPagingBufferReq(const struct SchedDlPagingBufferReqParameters& params) override;
-    void SchedDlMacBufferReq(const struct SchedDlMacBufferReqParameters& params) override;
-    void SchedDlTriggerReq(const struct SchedDlTriggerReqParameters& params) override;
-    void SchedDlRachInfoReq(const struct SchedDlRachInfoReqParameters& params) override;
-    void SchedDlCqiInfoReq(const struct SchedDlCqiInfoReqParameters& params) override;
-    void SchedUlTriggerReq(const struct SchedUlTriggerReqParameters& params) override;
-    void SchedUlNoiseInterferenceReq(
-        const struct SchedUlNoiseInterferenceReqParameters& params) override;
-    void SchedUlSrInfoReq(const struct SchedUlSrInfoReqParameters& params) override;
-    void SchedUlMacCtrlInfoReq(const struct SchedUlMacCtrlInfoReqParameters& params) override;
-    void SchedUlCqiInfoReq(const struct SchedUlCqiInfoReqParameters& params) override;
+    void SchedDlRlcBufferReq(const SchedDlRlcBufferReqParameters& params) override;
+    void SchedDlPagingBufferReq(const SchedDlPagingBufferReqParameters& params) override;
+    void SchedDlMacBufferReq(const SchedDlMacBufferReqParameters& params) override;
+    void SchedDlTriggerReq(const SchedDlTriggerReqParameters& params) override;
+    void SchedDlRachInfoReq(const SchedDlRachInfoReqParameters& params) override;
+    void SchedDlCqiInfoReq(const SchedDlCqiInfoReqParameters& params) override;
+    void SchedUlTriggerReq(const SchedUlTriggerReqParameters& params) override;
+    void SchedUlNoiseInterferenceReq(const SchedUlNoiseInterferenceReqParameters& params) override;
+    void SchedUlSrInfoReq(const SchedUlSrInfoReqParameters& params) override;
+    void SchedUlMacCtrlInfoReq(const SchedUlMacCtrlInfoReqParameters& params) override;
+    void SchedUlCqiInfoReq(const SchedUlCqiInfoReqParameters& params) override;
 
   private:
     C* m_scheduler; ///< the scheduler class
@@ -389,50 +374,49 @@
 
 template <class C>
 void
-MemberSchedSapProvider<C>::SchedDlRlcBufferReq(const struct SchedDlRlcBufferReqParameters& params)
+MemberSchedSapProvider<C>::SchedDlRlcBufferReq(const SchedDlRlcBufferReqParameters& params)
 {
     m_scheduler->DoSchedDlRlcBufferReq(params);
 }
 
 template <class C>
 void
-MemberSchedSapProvider<C>::SchedDlPagingBufferReq(
-    const struct SchedDlPagingBufferReqParameters& params)
+MemberSchedSapProvider<C>::SchedDlPagingBufferReq(const SchedDlPagingBufferReqParameters& params)
 {
     m_scheduler->DoSchedDlPagingBufferReq(params);
 }
 
 template <class C>
 void
-MemberSchedSapProvider<C>::SchedDlMacBufferReq(const struct SchedDlMacBufferReqParameters& params)
+MemberSchedSapProvider<C>::SchedDlMacBufferReq(const SchedDlMacBufferReqParameters& params)
 {
     m_scheduler->DoSchedDlMacBufferReq(params);
 }
 
 template <class C>
 void
-MemberSchedSapProvider<C>::SchedDlTriggerReq(const struct SchedDlTriggerReqParameters& params)
+MemberSchedSapProvider<C>::SchedDlTriggerReq(const SchedDlTriggerReqParameters& params)
 {
     m_scheduler->DoSchedDlTriggerReq(params);
 }
 
 template <class C>
 void
-MemberSchedSapProvider<C>::SchedDlRachInfoReq(const struct SchedDlRachInfoReqParameters& params)
+MemberSchedSapProvider<C>::SchedDlRachInfoReq(const SchedDlRachInfoReqParameters& params)
 {
     m_scheduler->DoSchedDlRachInfoReq(params);
 }
 
 template <class C>
 void
-MemberSchedSapProvider<C>::SchedDlCqiInfoReq(const struct SchedDlCqiInfoReqParameters& params)
+MemberSchedSapProvider<C>::SchedDlCqiInfoReq(const SchedDlCqiInfoReqParameters& params)
 {
     m_scheduler->DoSchedDlCqiInfoReq(params);
 }
 
 template <class C>
 void
-MemberSchedSapProvider<C>::SchedUlTriggerReq(const struct SchedUlTriggerReqParameters& params)
+MemberSchedSapProvider<C>::SchedUlTriggerReq(const SchedUlTriggerReqParameters& params)
 {
     m_scheduler->DoSchedUlTriggerReq(params);
 }
@@ -440,29 +424,28 @@
 template <class C>
 void
 MemberSchedSapProvider<C>::SchedUlNoiseInterferenceReq(
-    const struct SchedUlNoiseInterferenceReqParameters& params)
+    const SchedUlNoiseInterferenceReqParameters& params)
 {
     m_scheduler->DoSchedUlNoiseInterferenceReq(params);
 }
 
 template <class C>
 void
-MemberSchedSapProvider<C>::SchedUlSrInfoReq(const struct SchedUlSrInfoReqParameters& params)
+MemberSchedSapProvider<C>::SchedUlSrInfoReq(const SchedUlSrInfoReqParameters& params)
 {
     m_scheduler->DoSchedUlSrInfoReq(params);
 }
 
 template <class C>
 void
-MemberSchedSapProvider<C>::SchedUlMacCtrlInfoReq(
-    const struct SchedUlMacCtrlInfoReqParameters& params)
+MemberSchedSapProvider<C>::SchedUlMacCtrlInfoReq(const SchedUlMacCtrlInfoReqParameters& params)
 {
     m_scheduler->DoSchedUlMacCtrlInfoReq(params);
 }
 
 template <class C>
 void
-MemberSchedSapProvider<C>::SchedUlCqiInfoReq(const struct SchedUlCqiInfoReqParameters& params)
+MemberSchedSapProvider<C>::SchedUlCqiInfoReq(const SchedUlCqiInfoReqParameters& params)
 {
     m_scheduler->DoSchedUlCqiInfoReq(params);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/ff-mac-scheduler.h ns-3.39/src/lte/model/ff-mac-scheduler.h
--- ns-3.38/src/lte/model/ff-mac-scheduler.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/ff-mac-scheduler.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,6 +21,8 @@
 #ifndef FF_MAC_SCHEDULER_H
 #define FF_MAC_SCHEDULER_H
 
+#include "ff-mac-common.h"
+
 #include <ns3/object.h>
 
 namespace ns3
@@ -38,6 +40,37 @@
  * \defgroup ff-api FF MAC Schedulers
  */
 
+/// DL HARQ process status vector
+using DlHarqProcessesStatus_t = std::vector<uint8_t>;
+
+/// DL HARQ process timer vector
+using DlHarqProcessesTimer_t = std::vector<uint8_t>;
+
+/// DL HARQ process DCI buffer vector
+using DlHarqProcessesDciBuffer_t = std::vector<DlDciListElement_s>;
+
+/// Vector of the LCs and layers per UE
+using RlcPduList_t = std::vector<std::vector<RlcPduListElement_s>>;
+
+/// Vector of the 8 HARQ processes per UE
+using DlHarqRlcPduListBuffer_t = std::vector<RlcPduList_t>;
+
+/// UL HARQ process DCI buffer vector
+using UlHarqProcessesDciBuffer_t = std::vector<UlDciListElement_s>;
+
+/// UL HARQ process status vector
+using UlHarqProcessesStatus_t = std::vector<uint8_t>;
+
+/// Value for SINR outside the range defined by FF-API, used to indicate that there is
+/// no CQI for this element
+constexpr double NO_SINR = -5000;
+
+/// Number of HARQ processes
+constexpr uint32_t HARQ_PROC_NUM = 8;
+
+/// HARQ DL timeout
+constexpr uint32_t HARQ_DL_TIMEOUT = 11;
+
 /**
  * \ingroup ff-api
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-amc.cc ns-3.39/src/lte/model/lte-amc.cc
--- ns-3.38/src/lte/model/lte-amc.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-amc.cc	2023-07-05 14:23:48.009428000 -0700
@@ -19,12 +19,14 @@
  *                  Nicola Baldo   <nbaldo@cttc.es>
  */
 
+#include "lte-amc.h"
+
+#include "lte-mi-error-model.h"
+
 #include "ns3/enum.h"
 #include <ns3/assert.h>
 #include <ns3/double.h>
 #include <ns3/log.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-mi-error-model.h>
 #include <ns3/math.h>
 #include <ns3/spectrum-value.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-anr.cc ns-3.39/src/lte/model/lte-anr.cc
--- ns-3.38/src/lte/model/lte-anr.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-anr.cc	2023-07-05 14:23:48.009428000 -0700
@@ -174,7 +174,7 @@
                     // Update neighbour relation entry
                     NS_LOG_LOGIC(this << " updating NRT of cell " << m_servingCellId
                                       << " with entry of cell " << it->physCellId);
-                    if (itNrt->second.noX2 == false)
+                    if (!itNrt->second.noX2)
                     {
                         NS_LOG_LOGIC(this << " enabling handover"
                                           << " from cell " << m_servingCellId << " to cell "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-anr.h ns-3.39/src/lte/model/lte-anr.h
--- ns-3.38/src/lte/model/lte-anr.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-anr.h	2023-07-05 14:23:48.009428000 -0700
@@ -27,8 +27,9 @@
 #ifndef LTE_ANR_H
 #define LTE_ANR_H
 
-#include <ns3/lte-anr-sap.h>
-#include <ns3/lte-rrc-sap.h>
+#include "lte-anr-sap.h"
+#include "lte-rrc-sap.h"
+
 #include <ns3/object.h>
 
 #include <map>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-anr-sap.h ns-3.39/src/lte/model/lte-anr-sap.h
--- ns-3.38/src/lte/model/lte-anr-sap.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-anr-sap.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,7 +21,7 @@
 #ifndef LTE_ANR_SAP_H
 #define LTE_ANR_SAP_H
 
-#include <ns3/lte-rrc-sap.h>
+#include "lte-rrc-sap.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-asn1-header.cc ns-3.39/src/lte/model/lte-asn1-header.cc
--- ns-3.38/src/lte/model/lte-asn1-header.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-asn1-header.cc	2023-07-05 14:23:48.009428000 -0700
@@ -17,7 +17,7 @@
  * Author: Lluis Parcerisa <lparcerisa@cttc.cat>
  */
 
-#include "ns3/lte-asn1-header.h"
+#include "lte-asn1-header.h"
 
 #include "ns3/log.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-as-sap.cc ns-3.39/src/lte/model/lte-as-sap.cc
--- ns-3.38/src/lte/model/lte-as-sap.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-as-sap.cc	2023-07-05 14:23:48.009428000 -0700
@@ -17,7 +17,7 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include "ns3/lte-as-sap.h"
+#include "lte-as-sap.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ccm-mac-sap.h ns-3.39/src/lte/model/lte-ccm-mac-sap.h
--- ns-3.38/src/lte/model/lte-ccm-mac-sap.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-ccm-mac-sap.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,11 +21,8 @@
 #ifndef LTE_CCM_MAC_SAP_H
 #define LTE_CCM_MAC_SAP_H
 
-#include <ns3/eps-bearer.h>
-#include <ns3/ff-mac-common.h>
-#include <ns3/lte-enb-cmac-sap.h>
-#include <ns3/lte-mac-sap.h>
-#include <ns3/lte-rrc-sap.h>
+#include "ff-mac-common.h"
+#include "lte-mac-sap.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ccm-rrc-sap.h ns-3.39/src/lte/model/lte-ccm-rrc-sap.h
--- ns-3.38/src/lte/model/lte-ccm-rrc-sap.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-ccm-rrc-sap.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,10 +21,10 @@
 #ifndef LTE_CCM_RRC_SAP_H
 #define LTE_CCM_RRC_SAP_H
 
-#include <ns3/eps-bearer.h>
-#include <ns3/lte-enb-cmac-sap.h>
-#include <ns3/lte-mac-sap.h>
-#include <ns3/lte-rrc-sap.h>
+#include "eps-bearer.h"
+#include "lte-enb-cmac-sap.h"
+#include "lte-mac-sap.h"
+#include "lte-rrc-sap.h"
 
 #include <map>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-common.h ns-3.39/src/lte/model/lte-common.h
--- ns-3.38/src/lte/model/lte-common.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-common.h	2023-07-05 14:23:48.009428000 -0700
@@ -32,6 +32,12 @@
 namespace ns3
 {
 
+/// Minimum number of carrier components allowed by 3GPP up to R13
+constexpr uint32_t MIN_NO_CC = 1;
+
+/// Maximum number of carrier components allowed by 3GPP up to R13
+constexpr uint32_t MAX_NO_CC = 5;
+
 /// LteFlowId structure
 struct LteFlowId_t
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-control-messages.cc ns-3.39/src/lte/model/lte-control-messages.cc
--- ns-3.38/src/lte/model/lte-control-messages.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-control-messages.cc	2023-07-05 14:23:48.009428000 -0700
@@ -20,9 +20,6 @@
 
 #include "lte-control-messages.h"
 
-#include "lte-net-device.h"
-#include "lte-ue-net-device.h"
-
 #include "ns3/address-utils.h"
 #include "ns3/log.h"
 #include "ns3/uinteger.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-control-messages.h ns-3.39/src/lte/model/lte-control-messages.h
--- ns-3.38/src/lte/model/lte-control-messages.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-control-messages.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,8 +21,9 @@
 #ifndef LTE_CONTROL_MESSAGES_H
 #define LTE_CONTROL_MESSAGES_H
 
-#include <ns3/ff-mac-common.h>
-#include <ns3/lte-rrc-sap.h>
+#include "ff-mac-common.h"
+#include "lte-rrc-sap.h"
+
 #include <ns3/ptr.h>
 #include <ns3/simple-ref-count.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-cmac-sap.h ns-3.39/src/lte/model/lte-enb-cmac-sap.h
--- ns-3.38/src/lte/model/lte-enb-cmac-sap.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-cmac-sap.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,9 +21,6 @@
 #ifndef LTE_ENB_CMAC_SAP_H
 #define LTE_ENB_CMAC_SAP_H
 
-#include <ns3/eps-bearer.h>
-#include <ns3/ff-mac-common.h>
-#include <ns3/lte-common.h>
 #include <ns3/packet.h>
 
 namespace ns3
@@ -70,15 +67,16 @@
      */
     struct LcInfo
     {
-        uint16_t rnti;   /**< C-RNTI identifying the UE */
-        uint8_t lcId;    /**< logical channel identifier */
-        uint8_t lcGroup; /**< logical channel group */
-        uint8_t qci;     /**< QoS Class Identifier */
-        bool isGbr;      /**< true if the bearer is GBR, false if the bearer is NON-GBR */
-        uint64_t mbrUl;  /**< maximum bitrate in uplink */
-        uint64_t mbrDl;  /**< maximum bitrate in downlink */
-        uint64_t gbrUl;  /**< guaranteed bitrate in uplink */
-        uint64_t gbrDl;  /**< guaranteed bitrate in downlink */
+        uint16_t rnti;        /**< C-RNTI identifying the UE */
+        uint8_t lcId;         /**< logical channel identifier */
+        uint8_t lcGroup;      /**< logical channel group */
+        uint8_t qci;          /**< QoS Class Identifier */
+        uint8_t resourceType; /**< 0 if the bearer is NON-GBR, 1 if the bearer
+                                   is GBR, 2 if the bearer in DC-GBR */
+        uint64_t mbrUl;       /**< maximum bitrate in uplink */
+        uint64_t mbrDl;       /**< maximum bitrate in downlink */
+        uint64_t gbrUl;       /**< guaranteed bitrate in uplink */
+        uint64_t gbrDl;       /**< guaranteed bitrate in downlink */
     };
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-component-carrier-manager.cc ns-3.39/src/lte/model/lte-enb-component-carrier-manager.cc
--- ns-3.38/src/lte/model/lte-enb-component-carrier-manager.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-component-carrier-manager.cc	2023-07-05 14:23:48.009428000 -0700
@@ -20,6 +20,8 @@
 
 #include "lte-enb-component-carrier-manager.h"
 
+#include "lte-common.h"
+
 #include <ns3/log.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-component-carrier-manager.h ns-3.39/src/lte/model/lte-enb-component-carrier-manager.h
--- ns-3.38/src/lte/model/lte-enb-component-carrier-manager.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-component-carrier-manager.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,12 +21,13 @@
 #ifndef LTE_ENB_COMPONENT_CARRIER_MANAGER_H
 #define LTE_ENB_COMPONENT_CARRIER_MANAGER_H
 
-#include <ns3/lte-ccm-mac-sap.h>
-#include <ns3/lte-ccm-rrc-sap.h>
-#include <ns3/lte-enb-cmac-sap.h>
-#include <ns3/lte-enb-rrc.h>
-#include <ns3/lte-mac-sap.h>
-#include <ns3/lte-rrc-sap.h>
+#include "lte-ccm-mac-sap.h"
+#include "lte-ccm-rrc-sap.h"
+#include "lte-enb-cmac-sap.h"
+#include "lte-enb-rrc.h"
+#include "lte-mac-sap.h"
+#include "lte-rrc-sap.h"
+
 #include <ns3/object.h>
 
 #include <map>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-cphy-sap.cc ns-3.39/src/lte/model/lte-enb-cphy-sap.cc
--- ns-3.38/src/lte/model/lte-enb-cphy-sap.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-cphy-sap.cc	2023-07-05 14:23:48.009428000 -0700
@@ -17,7 +17,7 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include "ns3/lte-enb-cphy-sap.h"
+#include "lte-enb-cphy-sap.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-cphy-sap.h ns-3.39/src/lte/model/lte-enb-cphy-sap.h
--- ns-3.38/src/lte/model/lte-enb-cphy-sap.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-cphy-sap.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,7 +21,8 @@
 #ifndef LTE_ENB_CPHY_SAP_H
 #define LTE_ENB_CPHY_SAP_H
 
-#include <ns3/lte-rrc-sap.h>
+#include "lte-rrc-sap.h"
+
 #include <ns3/ptr.h>
 
 #include <stdint.h>
